image: registry.gitlab.com/zilliond/docker-images/php

stages:
  - build
  - publish

generate-zip:
  stage: build
  cache:
    paths:
      - vendor/
  before_script:
    - apk add --update zip git
  script:
    - mkdir -p releases
    - git archive --format zip HEAD > releases/release.zip
    - cp releases/release.zip releases/release-full.zip
    - cp .env.example .env
    - composer install
    - zip -r releases/release-full.zip vendor
  artifacts:
    paths:
      - releases

s3:
  image: xueshanf/awscli
  stage: publish
  dependencies:
    - generate-zip
  only:
    - tags
  variables:
    S3_OPTIONS: "-P --access_key=$S3_ACCESS_KEY --secret_key=$S3_SECRET_KEY --region=$S3_REGION --host=$S3_HOST --host-bucket=$S3_HOST_DNS"
  script:
    - mv releases/release.zip releases/latest.zip
    - mv releases/release-full.zip releases/latest-full.zip
    - ls releases
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-latest.zip" put releases/latest.zip      s3://$S3_BUCKET/zengine/releases/
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-latest-full.zip" put releases/latest-full.zip s3://$S3_BUCKET/zengine/releases/
    - mv releases/latest.zip releases/$CI_COMMIT_TAG.zip
    - mv releases/latest-full.zip releases/$CI_COMMIT_TAG-full.zip
    - ls releases
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-$CI_COMMIT_TAG.zip" put releases/$CI_COMMIT_TAG.zip s3://$S3_BUCKET/zengine/releases/
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-$CI_COMMIT_TAG-full.zip" put releases/$CI_COMMIT_TAG-full.zip s3://$S3_BUCKET/zengine/releases/

s3-dev:
  image: xueshanf/awscli
  stage: publish
  dependencies:
    - generate-zip
  except:
    refs:
      - tags
  variables:
    S3_OPTIONS: "-P --access_key=$S3_ACCESS_KEY --secret_key=$S3_SECRET_KEY --region=$S3_REGION --host=$S3_HOST --host-bucket=$S3_HOST_DNS"
  script:
    - mv releases/release.zip releases/dev-latest.zip
    - mv releases/release-full.zip releases/dev-latest-full.zip
    - ls releases
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-dev-latest.zip" put releases/dev-latest.zip s3://$S3_BUCKET/zengine/releases/
    - s3cmd $S3_OPTIONS --add-header="Content-Disposition:attachment; filename=zengine-dev-latest-full.zip" put releases/dev-latest-full.zip s3://$S3_BUCKET/zengine/releases/
